VST 3 Examples: VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage > Class Template Reference
Author: Steinberg

VST 3 Examples VST 3.7 SDK for developing VST plug-in

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage > Class Template Reference

Example Voice class for the Steinberg::Vst::VoiceProcessorImplementation. More...

`#include <voicebase.h>`

## Public Member Functions
int32 | getNoteId () const
| Returns the current note id of this voice.
virtual void | setGlobalParameterStorage (GlobalParameterStorage *globalParameters)
| Sets a new GlobalParameterStorage.
virtual void | setSampleRate (ParamValue sampleRate)
| Sets the sampleRate.
float | getSampleRate () const
| Returns the sampleRate.
virtual void | setNoteExpressionValue (int32 index, ParamValue value)
virtual void | noteOn (int32 pitch, ParamValue velocity, float tuning, int32 sampleOffset, int32 noteId)
virtual void | noteOff (ParamValue velocity, int32 sampleOffset)
virtual void | reset ()

## Protected Member Functions
| VoiceBase ()
| VoiceBase (const VoiceBase &vb)
virtual | ~VoiceBase ()

## Protected Attributes
GlobalParameterStorage * | globalParameters
int32 | noteId
int32 | pitch
int32 | noteOnSampleOffset
int32 | noteOffSampleOffset
float | tuning
ParamValue | sampleRate
ParamValue | noteOnVelocity
ParamValue | noteOffVelocity
ParamValue | values [numValues]

## Detailed Description

### template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>
class Steinberg::Vst::VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage >

Example Voice class for the Steinberg::Vst::VoiceProcessorImplementation.

Implementation classes need to implement the following additional method:

bool process (SamplePrecision* outputBuffers[numChannels], int32 numSamples);

## Constructor & Destructor Documentation

VoiceBase | ( |  | ) |
| protected

VoiceBase | ( | const VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage > & | vb | ) |
| protected

~VoiceBase | ( |  | ) |
| protectedvirtual

## Member Function Documentation

int32 getNoteId | ( |  | ) | const
| inline

Returns the current note id of this voice.

virtual void setGlobalParameterStorage | ( | GlobalParameterStorage * | globalParameters | ) |
| inlinevirtual

Sets a new GlobalParameterStorage.

virtual void setSampleRate | ( | ParamValue | sampleRate | ) |
| inlinevirtual

Sets the sampleRate.

Reimplemented in Voice< SamplePrecision >.

float getSampleRate | ( |  | ) | const
| inline

Returns the sampleRate.

virtual void setNoteExpressionValue | ( | int32 | index,
|  | ParamValue | value
| ) |  |
| inlinevirtual

Reimplemented in Voice< SamplePrecision >.

void noteOn | ( | int32 | pitch,
|  | ParamValue | velocity,
|  | float | tuning,
|  | int32 | sampleOffset,
|  | int32 | noteId
| ) |  |
| virtual

Reimplemented in Voice< SamplePrecision >.

void noteOff | ( | ParamValue | velocity,
|  | int32 | sampleOffset
| ) |  |
| virtual

Reimplemented in Voice< SamplePrecision >.

virtual void reset | ( |  | ) |
| inlinevirtual

Reimplemented in Voice< SamplePrecision >.

## Member Data Documentation

GlobalParameterStorage* globalParameters
| protected

int32 noteId
| protected

int32 pitch
| protected

int32 noteOnSampleOffset
| protected

int32 noteOffSampleOffset
| protected

float tuning
| protected

ParamValue sampleRate
| protected

ParamValue noteOnVelocity
| protected

ParamValue noteOffVelocity
| protected

ParamValue values[numValues]
| protected

Empty

Copyright ©2024 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.